/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.39 from the
 * contents of SDL_perl.xs. Do not edit this file, edit SDL_perl.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "lib/SDL_perl.xs"
/* */
/* SDL.xs */
/* */
/* Copyright (C) 2005 David J. Goehrig <dgoehrig@cpan.org> */
/* */
/* ------------------------------------------------------------------------------ */
/* */
/* This library is free software; you can redistribute it and/or */
/* modify it under the terms of the GNU Lesser General Public */
/* License as published by the Free Software Foundation; either */
/* version 2.1 of the License, or (at your option) any later version. */
/*  */
/* This library is distributed in the hope that it will be useful, */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/* Lesser General Public License for more details. */
/*  */
/* You should have received a copy of the GNU Lesser General Public */
/* License along with this library; if not, write to the Free Software */
/* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA */
/* */
/* ------------------------------------------------------------------------------ */
/* */
/* Please feel free to send questions, suggestions or improvements to: */
/* */
/*	David J. Goehrig */
/*	dgoehrig@cpan.org */
/* */

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include "ppport.h"

#ifndef aTHX_
#define aTHX_
#endif

#include <SDL.h>


#ifdef HAVE_GL
#include <gl.h>
#endif

#ifdef HAVE_GLU
#include <glu.h>
#endif


#ifdef USE_THREADS
#define HAVE_TLS_CONTEXT
#endif

/* For windows  */
#ifndef SDL_PERL_DEFINES_H
#define SDL_PERL_DEFINES_H

#ifdef HAVE_TLS_CONTEXT
PerlInterpreter *parent_perl = NULL;
extern PerlInterpreter *parent_perl;
#define GET_TLS_CONTEXT parent_perl =  PERL_GET_CONTEXT;
#define ENTER_TLS_CONTEXT \
        PerlInterpreter *current_perl = PERL_GET_CONTEXT; \
	        PERL_SET_CONTEXT(parent_perl); { \
			                PerlInterpreter *my_perl = parent_perl;
#define LEAVE_TLS_CONTEXT \
					        } PERL_SET_CONTEXT(current_perl);
#else
#define GET_TLS_CONTEXT         /* TLS context not enabled */
#define ENTER_TLS_CONTEXT       /* TLS context not enabled */
#define LEAVE_TLS_CONTEXT       /* TLS context not enabled */
#endif

#endif

#if defined WINDOWS || defined WIN32 
#include <SDL_syswm.h>
#include<windows.h> 
   extern int SDL_RegisterApp (char*, Uint32, void*);

HWND get_handle_win32( )
{
	SDL_SysWMinfo SysInfo; //Will hold our Window information
	SDL_VERSION(&SysInfo.version); //Set SDL version
	 
	if(SDL_GetWMInfo(&SysInfo) <= 0) {
		printf("%s : %d\n", SDL_GetError(), SysInfo.window);
		return NULL;
	}
	 
	return SysInfo.window; //There it is, Win32 handle

}
#endif

#ifndef NOSIGCATCH
#include <execinfo.h>
#include <signal.h>
#include <stdlib.h>

void handler(int sig) {
  void *array[10];
  size_t size;

   /*get void*'s for all entries on the stack */
     size = backtrace(array, 10);
  
    /* print out all the frames to stderr */
         fprintf(stderr, "Error: signal %d:\n", sig);
           backtrace_symbols_fd(array, size, 2);
      exit(1);
}
#endif

void
windows_force_driver()
{
	char *test;
#if SDL_MAJOR_VERSION >= 1 && SDL_MINOR_VERSION >= 2 &&  SDL_PATCHLEVEL >= 9
    test = SDL_getenv("SDL_VIDEODRIVER");
#else
	test = getenv("SDL_VIDEODRIVER");
#endif 
	if(!test || 0 != strcmp("dummy", test))
	{
#if SDL_MAJOR_VERSION >= 1 && SDL_MINOR_VERSION >= 2 &&  SDL_PATCHLEVEL >= 14
		putenv("SDL_VIDEODRIVER=directx");
#else
		putenv("SDL_VIDEODRIVER=windib");
#endif
	}
}


#define INIT_NS_APPLICATION
#define QUIT_NS_APPLICATION


void
sdl_perl_atexit (void)
{
	QUIT_NS_APPLICATION	
	SDL_Quit();
}

void boot_SDL();
void boot_SDL__OpenGL();

XS(boot_SDL_perl)
{

#ifndef NOSIGCATCH 
	signal(SIGSEGV, handler);
#endif
	PL_perl_destruct_level = 2;
	GET_TLS_CONTEXT
	boot_SDL();

#if defined WINDOWS || defined WIN32
  SDL_RegisterApp ("SDLPerl App", 0, GetModuleHandle (NULL));
#endif

}


#line 177 "lib/SDL_perl.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 321 "lib/SDL_perl.c"

XS_EUPXS(XS_SDL_set_error_real); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_SDL_set_error_real)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "fmt, ...");
    {
	char *	fmt = (char *)SvPV_nolen(ST(0))
;
#line 177 "lib/SDL_perl.xs"
		SDL_SetError(fmt, items);
#line 334 "lib/SDL_perl.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_SDL_get_error); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_SDL_get_error)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	char *	RETVAL;
	dXSTARG;
#line 182 "lib/SDL_perl.xs"
		RETVAL = SDL_GetError();
#line 351 "lib/SDL_perl.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_SDL_clear_error); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_SDL_clear_error)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 189 "lib/SDL_perl.xs"
		SDL_ClearError();
#line 367 "lib/SDL_perl.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_SDL_init); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_SDL_init)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "flags");
    {
	Uint32	flags = (Uint32)SvUV(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 195 "lib/SDL_perl.xs"
		INIT_NS_APPLICATION
#if defined WINDOWS || defined WIN32
		windows_force_driver();
#endif
		RETVAL = SDL_Init(flags);
#ifndef WINDOWS 
#ifndef WIN32
#ifdef HAVE_TLS_CONTEXT 

		call_atexit((void*)sdl_perl_atexit,0);
#else
		atexit(sdl_perl_atexit);
#endif
#endif
#endif
#line 400 "lib/SDL_perl.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_SDL_init_sub_system); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_SDL_init_sub_system)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "flags");
    {
	Uint32	flags = (Uint32)SvUV(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 217 "lib/SDL_perl.xs"
		RETVAL = SDL_InitSubSystem(flags);
#line 420 "lib/SDL_perl.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_SDL_quit_sub_system); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_SDL_quit_sub_system)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "flags");
    {
	Uint32	flags = (Uint32)SvUV(ST(0))
;
#line 225 "lib/SDL_perl.xs"
		SDL_QuitSubSystem(flags);
#line 438 "lib/SDL_perl.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_SDL_quit); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_SDL_quit)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 230 "lib/SDL_perl.xs"
		QUIT_NS_APPLICATION
		SDL_Quit();
#line 454 "lib/SDL_perl.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_SDL_was_init); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_SDL_was_init)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "flags");
    {
	Uint32	flags = (Uint32)SvUV(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 237 "lib/SDL_perl.xs"
		RETVAL = SDL_WasInit(flags);
#line 473 "lib/SDL_perl.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_SDL_version); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_SDL_version)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 244 "lib/SDL_perl.xs"
		char * CLASS = "SDL::Version";
		SDL_version *version;
#line 490 "lib/SDL_perl.c"
	SDL_version *	RETVAL;
#line 247 "lib/SDL_perl.xs"
	 	version = (SDL_version *) safemalloc (sizeof(SDL_version));
		SDL_VERSION(version);
		RETVAL = version;
#line 496 "lib/SDL_perl.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
    if (RETVAL) {
	    void** pointers  = malloc(3 * sizeof(void*));
	    pointers[0]      = (void*)RETVAL;
	    pointers[1]      = (void*)PERL_GET_CONTEXT;
	    Uint32 *threadid = (Uint32 *)safemalloc(sizeof(Uint32));
	    *threadid	= SDL_ThreadID();
	    pointers[2]      = (void*)threadid;
	    sv_setref_pv( RETVALSV, CLASS, (void*)pointers );
    } else {
	    XSRETURN_UNDEF;
    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_SDL_linked_version); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_SDL_linked_version)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 256 "lib/SDL_perl.xs"
		char * CLASS = "SDL::Version";
		SDL_version *version;
#line 528 "lib/SDL_perl.c"
	SDL_version *	RETVAL;
#line 259 "lib/SDL_perl.xs"
		version = (SDL_version *) safemalloc ( sizeof(SDL_version) );
		SDL_version* version_dont_free = (SDL_version *) SDL_Linked_Version();

		version->major = version_dont_free->major;
		version->minor = version_dont_free->minor;
		version->patch = version_dont_free->patch;
		RETVAL = version;
#line 538 "lib/SDL_perl.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
    if (RETVAL) {
	    void** pointers  = malloc(3 * sizeof(void*));
	    pointers[0]      = (void*)RETVAL;
	    pointers[1]      = (void*)PERL_GET_CONTEXT;
	    Uint32 *threadid = (Uint32 *)safemalloc(sizeof(Uint32));
	    *threadid	= SDL_ThreadID();
	    pointers[2]      = (void*)threadid;
	    sv_setref_pv( RETVALSV, CLASS, (void*)pointers );
    } else {
	    XSRETURN_UNDEF;
    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_SDL_getenv); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_SDL_getenv)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "name");
    {
	char *	name = (char *)SvPV_nolen(ST(0))
;
	char *	RETVAL;
	dXSTARG;
#line 273 "lib/SDL_perl.xs"
	char *test;
	/* SDL version 1.2.9 doesn't have SDL_getenv */
#if SDL_MAJOR_VERSION >= 1 && SDL_MINOR_VERSION >= 2 &&  SDL_PATCHLEVEL >= 9
    test = SDL_getenv(name);
#else
    test = getenv(name);
#endif	
		RETVAL = test;
#line 580 "lib/SDL_perl.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_SDL_delay); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_SDL_delay)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ms");
    {
	int	ms = (int)SvIV(ST(0))
;
#line 288 "lib/SDL_perl.xs"
		SDL_Delay(ms);
#line 598 "lib/SDL_perl.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_SDL_get_ticks); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_SDL_get_ticks)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	Uint32	RETVAL;
	dXSTARG;
#line 293 "lib/SDL_perl.xs"
		RETVAL = SDL_GetTicks();
#line 615 "lib/SDL_perl.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_SDL_get_handle); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_SDL_get_handle)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	IV	RETVAL;
	dXSTARG;
#line 301 "lib/SDL_perl.xs"
#if defined WINDOWS || defined WIN32
		RETVAL = (IV)get_handle_win32();
#else
		RETVAL = 0;
#endif
#line 637 "lib/SDL_perl.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_SDL); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_SDL)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("SDL::set_error_real", XS_SDL_set_error_real);
        newXS_deffile("SDL::get_error", XS_SDL_get_error);
        newXS_deffile("SDL::clear_error", XS_SDL_clear_error);
        newXS_deffile("SDL::init", XS_SDL_init);
        newXS_deffile("SDL::init_sub_system", XS_SDL_init_sub_system);
        newXS_deffile("SDL::quit_sub_system", XS_SDL_quit_sub_system);
        newXS_deffile("SDL::quit", XS_SDL_quit);
        newXS_deffile("SDL::was_init", XS_SDL_was_init);
        newXS_deffile("SDL::version", XS_SDL_version);
        newXS_deffile("SDL::linked_version", XS_SDL_linked_version);
        newXS_deffile("SDL::getenv", XS_SDL_getenv);
        newXS_deffile("SDL::delay", XS_SDL_delay);
        newXS_deffile("SDL::get_ticks", XS_SDL_get_ticks);
        newXS_deffile("SDL::get_handle", XS_SDL_get_handle);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

