/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.39 from the
 * contents of Interface.xs. Do not edit this file, edit Interface.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "lib/SDLx/Controller/Interface.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include "ppport.h"
#include "defines.h"
#include "helper.h"

#ifndef aTHX_
#define aTHX_
#endif

#include "SDLx/Controller/Interface.h"

AV *acceleration_cb( SDLx_Interface *obj, float t )
{
	SV *tmpsv;
	if( !(SvROK(obj->acceleration) && (tmpsv = obj->acceleration) ) )
		croak( "Interface doesn't not contain an acceleration callback" );

	dSP;
	AV *array = newAV();
	int i;
	int count;
	SDLx_State *copyState = (SDLx_State *)safemalloc( sizeof(SDLx_State) );
	copy_state( copyState, obj->current );
	copyState->owned = 0;
	ENTER;
	SAVETMPS;
	PUSHMARK(SP);
	XPUSHs( sv_2mortal(newSVnv(t)) );
	XPUSHs( sv_2mortal( obj2bag( sizeof(SDLx_State *), (void *)copyState, "SDLx::Controller::State" ) ) );
	PUTBACK;

	count = call_sv( obj->acceleration, G_ARRAY );

	SPAGAIN;
/*	warn( "state %p, state->x %f", copyState, ((SDLx_State *)copyState)->x ); */
	for( i = 0; i < count; i++ )
		av_push( array, newSVnv(POPn) );

/*	warn ("before obj->current->x %f", obj->current->x); */
	copy_state( obj->current, copyState );
/*	warn ("after obj->current->x %f", obj->current->x); */
	PUTBACK;
	FREETMPS;
	LEAVE;

	return array;
}

void evaluate(SDLx_Interface *obj, SDLx_Derivative *out, SDLx_State *initial, float t)
{
	out->dx        = initial->v_x;
	out->dy        = initial->v_y;
	out->drotation = initial->ang_v;
	AV *accel      = acceleration_cb(obj, t);

	SV *temp;
	temp           = av_pop(accel);
	out->dv_x      = sv_nv(temp);
	SvREFCNT_dec(temp);

	temp           = av_pop(accel);
	out->dv_y      = sv_nv(temp);
	SvREFCNT_dec(temp);

	temp           = av_pop(accel);
	out->dang_v    = sv_nv(temp);
	SvREFCNT_dec(temp);

	SvREFCNT_dec((SV *)accel);
}

void evaluate_dt(SDLx_Interface *obj, SDLx_Derivative *out, SDLx_State *initial, float t, float dt, SDLx_Derivative *d)
{
	SDLx_State state;
	state.x        = initial->x        + d->dx        * dt;
	state.y        = initial->y        + d->dy        * dt;
	state.rotation = initial->rotation + d->drotation * dt;

	state.v_x      = initial->v_x      + d->dv_x      * dt;
	state.v_y      = initial->v_y      + d->dv_y      * dt;
	state.ang_v    = initial->ang_v    + d->dang_v    * dt;

	out->dx        = state.v_x;
	out->dy        = state.v_y;
	out->drotation = state.ang_v;

	AV *accel      = acceleration_cb(obj, t+dt);

	SV *temp;
	temp           = av_pop(accel);
	out->dv_x      = sv_nv(temp);
	SvREFCNT_dec(temp);

	temp           = av_pop(accel);
	out->dv_y      = sv_nv(temp);
	SvREFCNT_dec(temp);

	temp           = av_pop(accel);
	out->dang_v    = sv_nv(temp);
	SvREFCNT_dec(temp);

	SvREFCNT_dec((SV *)accel);
}

void integrate( SDLx_Interface *object, float t, float dt)
{
	SDLx_State *state  = object->current;
	SDLx_Derivative *a = (SDLx_Derivative *)safemalloc( sizeof(SDLx_Derivative) );
	SDLx_Derivative *b = (SDLx_Derivative *)safemalloc( sizeof(SDLx_Derivative) );
	SDLx_Derivative *c = (SDLx_Derivative *)safemalloc( sizeof(SDLx_Derivative) );
	SDLx_Derivative *d = (SDLx_Derivative *)safemalloc( sizeof(SDLx_Derivative) );

	 evaluate(object, a, state, t);
	 evaluate_dt(object, b, state, t, dt*0.5f, a);
	 evaluate_dt(object, c, state, t, dt*0.5f, b);
	 evaluate_dt(object, d, state, t, dt, c);

	const float dxdt        = 1.0f/6.0f * (a->dx        + 2.0f * (b->dx        + c->dx)        + d->dx);
	const float dv_xdt      = 1.0f/6.0f * (a->dv_x      + 2.0f * (b->dv_x      + c->dv_x)      + d->dv_x);
	const float dydt        = 1.0f/6.0f * (a->dy        + 2.0f * (b->dy        + c->dy)        + d->dy);
	const float dv_ydt      = 1.0f/6.0f * (a->dv_y      + 2.0f * (b->dv_y      + c->dv_y)      + d->dv_y);
	const float drotationdt = 1.0f/6.0f * (a->drotation + 2.0f * (b->drotation + c->drotation) + d->drotation);
	const float dv_angdt    = 1.0f/6.0f * (a->dang_v    + 2.0f * (b->dang_v    + c->dang_v)    + d->dang_v);

	state->x        = state->x        + dxdt        * dt;
	state->v_x      = state->v_x      + dv_xdt      * dt;
	state->y        = state->y        + dydt        * dt;
	state->v_y      = state->v_y      + dv_ydt      * dt;
	state->rotation = state->rotation + drotationdt * dt;
	state->ang_v    = state->ang_v    + dv_angdt    * dt;

	safefree(a);
	safefree(b);
	safefree(c);
	safefree(d);
}

#line 150 "lib/SDLx/Controller/Interface.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 294 "lib/SDLx/Controller/Interface.c"

XS_EUPXS(XS_SDLx__Controller__Interface_make); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_SDLx__Controller__Interface_make)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "CLASS, ...");
    {
	char *	CLASS = (char *)SvPV_nolen(ST(0))
;
	SDLx_Interface *	RETVAL;
#line 146 "lib/SDLx/Controller/Interface.xs"
		RETVAL               = (SDLx_Interface *)safemalloc( sizeof(SDLx_Interface) );
		RETVAL->previous     = (SDLx_State *)safemalloc( sizeof(SDLx_State) );
		RETVAL->current      = (SDLx_State *)safemalloc( sizeof(SDLx_State) );
		RETVAL->acceleration = newSViv(-1);

		RETVAL->current->x        = 0;
		RETVAL->current->y        = 0;
		RETVAL->current->v_x      = 0;
		RETVAL->current->v_y      = 0;
		RETVAL->current->rotation = 0;
		RETVAL->current->ang_v    = 0;
		RETVAL->current->owned    = 1;
		RETVAL->previous->owned   = 1;

		if(items > 1) (RETVAL->current)->x        = SvIV(ST(1));
		if(items > 2) (RETVAL->current)->y        = SvIV(ST(2));
		if(items > 3) (RETVAL->current)->v_x      = SvIV(ST(3));
		if(items > 4) (RETVAL->current)->v_y      = SvIV(ST(4));
		if(items > 5) (RETVAL->current)->rotation = SvIV(ST(5));
		if(items > 6) (RETVAL->current)->ang_v    = SvIV(ST(6));

		copy_state(RETVAL->previous, RETVAL->current);
#line 329 "lib/SDLx/Controller/Interface.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
    if (RETVAL) {
	    void** pointers  = malloc(3 * sizeof(void*));
	    pointers[0]      = (void*)RETVAL;
	    pointers[1]      = (void*)PERL_GET_CONTEXT;
	    Uint32 *threadid = (Uint32 *)safemalloc(sizeof(Uint32));
	    *threadid	= SDL_ThreadID();
	    pointers[2]      = (void*)threadid;
	    sv_setref_pv( RETVALSV, CLASS, (void*)pointers );
    } else {
	    XSRETURN_UNDEF;
    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_SDLx__Controller__Interface_set_acceleration); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_SDLx__Controller__Interface_set_acceleration)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "obj, callback");
    {
	SDLx_Interface *	obj;
	SV *	callback = ST(1)
;

    if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) ) {
        void** pointers = (void**)INT2PTR(void *, SvIV((SV *)SvRV( ST(0) )));
        obj = (SDLx_Interface *)(pointers[0]);
    } else if (ST(0) == 0) {
        XSRETURN(0);
    } else {
        XSRETURN_UNDEF;
    }
;
#line 176 "lib/SDLx/Controller/Interface.xs"
		SV *tmpsv = NULL;
		if( !(SvROK(callback) && (tmpsv = (SV*)SvRV(callback)) &&  SvTYPE(tmpsv) == SVt_PVCV ) )
			croak( "Acceleration callback needs to be a code ref, %p", callback );
		obj->acceleration = SvRV( newRV_inc(callback) );
#line 376 "lib/SDLx/Controller/Interface.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_SDLx__Controller__Interface_acceleration); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_SDLx__Controller__Interface_acceleration)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "obj, t");
    {
	SDLx_Interface*	obj;
	float	t = (float)SvNV(ST(1))
;
	AV *	RETVAL;

    if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) ) {
        void** pointers = (void**)INT2PTR(void *, SvIV((SV *)SvRV( ST(0) )));
        obj = (SDLx_Interface *)(pointers[0]);
    } else if (ST(0) == 0) {
        XSRETURN(0);
    } else {
        XSRETURN_UNDEF;
    }
;
#line 186 "lib/SDLx/Controller/Interface.xs"
		RETVAL = acceleration_cb(obj, t);
		sv_2mortal((SV*)RETVAL);
#line 406 "lib/SDLx/Controller/Interface.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_SDLx__Controller__Interface_interpolate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_SDLx__Controller__Interface_interpolate)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "obj, alpha");
    {
	SDLx_Interface *	obj;
	float	alpha = (float)SvNV(ST(1))
;
#line 196 "lib/SDLx/Controller/Interface.xs"
		char *CLASS = "SDLx::Controller::State";
#line 430 "lib/SDLx/Controller/Interface.c"
	SDLx_State *	RETVAL;

    if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) ) {
        void** pointers = (void**)INT2PTR(void *, SvIV((SV *)SvRV( ST(0) )));
        obj = (SDLx_Interface *)(pointers[0]);
    } else if (ST(0) == 0) {
        XSRETURN(0);
    } else {
        XSRETURN_UNDEF;
    }
;
#line 198 "lib/SDLx/Controller/Interface.xs"
		SDLx_State *out = (SDLx_State *)safemalloc(sizeof(SDLx_State ));
		interpolate( obj,out, alpha);
		out->owned = 0; /* condition free */
		RETVAL     = out;
#line 447 "lib/SDLx/Controller/Interface.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
    if (RETVAL) {
	    void** pointers  = malloc(3 * sizeof(void*));
	    pointers[0]      = (void*)RETVAL;
	    pointers[1]      = (void*)PERL_GET_CONTEXT;
	    Uint32 *threadid = (Uint32 *)safemalloc(sizeof(Uint32));
	    *threadid	= SDL_ThreadID();
	    pointers[2]      = (void*)threadid;
	    sv_setref_pv( RETVALSV, CLASS, (void*)pointers );
    } else {
	    XSRETURN_UNDEF;
    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_SDLx__Controller__Interface_current); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_SDLx__Controller__Interface_current)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "obj, ...");
    {
	SDLx_Interface *	obj;
#line 209 "lib/SDLx/Controller/Interface.xs"
		char * CLASS = "SDLx::Controller::State";
#line 479 "lib/SDLx/Controller/Interface.c"
	SDLx_State *	RETVAL;

    if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) ) {
        void** pointers = (void**)INT2PTR(void *, SvIV((SV *)SvRV( ST(0) )));
        obj = (SDLx_Interface *)(pointers[0]);
    } else if (ST(0) == 0) {
        XSRETURN(0);
    } else {
        XSRETURN_UNDEF;
    }
;
#line 211 "lib/SDLx/Controller/Interface.xs"
		RETVAL = obj->current;
#line 493 "lib/SDLx/Controller/Interface.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
    if (RETVAL) {
	    void** pointers  = malloc(3 * sizeof(void*));
	    pointers[0]      = (void*)RETVAL;
	    pointers[1]      = (void*)PERL_GET_CONTEXT;
	    Uint32 *threadid = (Uint32 *)safemalloc(sizeof(Uint32));
	    *threadid	= SDL_ThreadID();
	    pointers[2]      = (void*)threadid;
	    sv_setref_pv( RETVALSV, CLASS, (void*)pointers );
    } else {
	    XSRETURN_UNDEF;
    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_SDLx__Controller__Interface_previous); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_SDLx__Controller__Interface_previous)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "obj, ...");
    {
	SDLx_Interface *	obj;
#line 219 "lib/SDLx/Controller/Interface.xs"
		char *CLASS = "SDLx::Controller::State";
#line 525 "lib/SDLx/Controller/Interface.c"
	SDLx_State *	RETVAL;

    if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) ) {
        void** pointers = (void**)INT2PTR(void *, SvIV((SV *)SvRV( ST(0) )));
        obj = (SDLx_Interface *)(pointers[0]);
    } else if (ST(0) == 0) {
        XSRETURN(0);
    } else {
        XSRETURN_UNDEF;
    }
;
#line 221 "lib/SDLx/Controller/Interface.xs"
		RETVAL = obj->previous;
#line 539 "lib/SDLx/Controller/Interface.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
    if (RETVAL) {
	    void** pointers  = malloc(3 * sizeof(void*));
	    pointers[0]      = (void*)RETVAL;
	    pointers[1]      = (void*)PERL_GET_CONTEXT;
	    Uint32 *threadid = (Uint32 *)safemalloc(sizeof(Uint32));
	    *threadid	= SDL_ThreadID();
	    pointers[2]      = (void*)threadid;
	    sv_setref_pv( RETVALSV, CLASS, (void*)pointers );
    } else {
	    XSRETURN_UNDEF;
    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_SDLx__Controller__Interface_update); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_SDLx__Controller__Interface_update)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "obj, t, dt");
    {
	SDLx_Interface *	obj;
	float	t = (float)SvNV(ST(1))
;
	float	dt = (float)SvNV(ST(2))
;

    if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) ) {
        void** pointers = (void**)INT2PTR(void *, SvIV((SV *)SvRV( ST(0) )));
        obj = (SDLx_Interface *)(pointers[0]);
    } else if (ST(0) == 0) {
        XSRETURN(0);
    } else {
        XSRETURN_UNDEF;
    }
;
#line 231 "lib/SDLx/Controller/Interface.xs"
		copy_state( obj->previous, obj->current);
		integrate( obj, t, dt );
#line 586 "lib/SDLx/Controller/Interface.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_SDLx__Controller__Interface_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_SDLx__Controller__Interface_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "obj");
    {
	SDLx_Interface *	obj;

    if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) ) {
        void** pointers = (void**)INT2PTR(void *, SvIV((SV *)SvRV( ST(0) )));
        obj = (SDLx_Interface *)(pointers[0]);
    } else if (ST(0) == 0) {
        XSRETURN(0);
    } else {
        XSRETURN_UNDEF;
    }
;
#line 238 "lib/SDLx/Controller/Interface.xs"
		SvREFCNT_dec(obj->acceleration);
		safefree(obj->previous);
		safefree(obj->current);
		safefree(obj);
#line 615 "lib/SDLx/Controller/Interface.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_SDLx__Controller__Interface); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_SDLx__Controller__Interface)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("SDLx::Controller::Interface::make", XS_SDLx__Controller__Interface_make);
        newXS_deffile("SDLx::Controller::Interface::set_acceleration", XS_SDLx__Controller__Interface_set_acceleration);
        newXS_deffile("SDLx::Controller::Interface::acceleration", XS_SDLx__Controller__Interface_acceleration);
        newXS_deffile("SDLx::Controller::Interface::interpolate", XS_SDLx__Controller__Interface_interpolate);
        newXS_deffile("SDLx::Controller::Interface::current", XS_SDLx__Controller__Interface_current);
        newXS_deffile("SDLx::Controller::Interface::previous", XS_SDLx__Controller__Interface_previous);
        newXS_deffile("SDLx::Controller::Interface::update", XS_SDLx__Controller__Interface_update);
        newXS_deffile("SDLx::Controller::Interface::DESTROY", XS_SDLx__Controller__Interface_DESTROY);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

